//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double T3Period1  =  32;
extern double T3Period2  =   5;
extern double T3Period3  =   5;
extern double T3Hot      = 0.4;
extern bool   T3Original = false;
extern int    T3Price    = PRICE_CLOSE;

double tsi[];
double tsili[];
double tsihuu[];
double tsihdd[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,tsihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tsihdd); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tsili);
   SetIndexBuffer(3,tsi);
   SetIndexBuffer(4,slope);
      T3Period1 = MathMax(T3Period1,1);
      T3Period2 = MathMax(T3Period2,1);
      T3Period3 = MathMax(T3Period3,1);
      IndicatorShortName("Blau T3 true strenngth index  trend("+DoubleToStr(T3Period1,1)+","+DoubleToStr(T3Period2,1)+","+DoubleToStr(T3Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,T3Price,i)-iMA(NULL,0,1,0,MODE_SMA,T3Price,i+1);
         double avg = iT3(iT3(iT3(        priceDiff ,T3Period1,T3Hot,T3Original,i,0),T3Period2,T3Hot,T3Original,i,1),T3Period3,T3Hot,T3Original,i,2);
         double ava = iT3(iT3(iT3(MathAbs(priceDiff),T3Period1,T3Hot,T3Original,i,3),T3Period2,T3Hot,T3Original,i,4),T3Period3,T3Hot,T3Original,i,5);
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
            tsihuu[i] = EMPTY_VALUE;
            tsihdd[i] = EMPTY_VALUE;
            tsili[i]  = 0;

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (tsi[i] > tsi[i+1]) slope[i] =  1;
               if (tsi[i] < tsi[i+1]) slope[i] = -1;
               if (tsi[i] > 0 && slope[i] ==  1) { tsihuu[i] = tsi[i]; tsili[i] = tsi[i]; }
               if (tsi[i] < 0 && slope[i] == -1) { tsihdd[i] = tsi[i]; tsili[i] = tsi[i]; }
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][36];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}